#attrib <<#include "sym.h">>

<<
#include "gen.h"

Sym *CurSym;
int CurVal;

main()
{
	aSymInit(HTsize, STRsize);
	ANTLR(smallC, stdin);
}

/*
 * Convert a lexical object into an attribute
 * In this case, the we told the lexical analyzer to do a lot.  aCreate()
 * doesn't have to do much.
 */
aCreate(attr)
Attrib *attr;
{
	switch ( Token )
	{
		case WORD :
		case FUNC :
		case VAR :
			attr->sym = CurSym;
			break;
		case Number :
			attr->ival = CurVal;
			break;
	}
}
>>

#token "[\t\ ]"		<< LexSkip(); >>
#token "\n"			<< lex_line++; LexSkip(); >>

smallC	:	<<Sym *globals=NULL; gen(Jump, "main"); aSymScope(&globals);>>
			decls[{$1.ival=GLOBAL;}]
			( func <<aSymScope(&globals);>> )*
			"@"
			<<aSymRmScope(&globals);>>
		;

decls	:	(	<< int offset=LocalStart; >>
				"int"
				(	WORD <<	aSymAdd($1.sym->symbol, $1.sym);
							$1.sym->token = VAR;
							$1.sym->level = $$.ival;
							$1.sym->offset = offset--;
							if ( $$.ival==LOCAL ) gen(Local);
							else gen(Global, $1.sym->symbol); >>
				|	VAR  <<	if ( $1.sym->level == $$.ival ) {
								Cerror("redecl of '%s' ignored\n",
										$1.sym->symbol);
							}
							else {
								aSymAdd($1.sym->symbol, $1.sym);
								$1.sym->token = VAR;
								$1.sym->level = LOCAL;
								$1.sym->offset = offset--;
								gen(Local);
							}
							>>
				)
				";"
			)*
		;

func	:	<<Sym *locals=NULL;>>
			WORD		<< gen(Label, $1.sym->symbol);
						   aSymAdd($1.sym->symbol, $1.sym);
						   $1.sym->token = FUNC;
						   $1.sym->level = GLOBAL;
						   $1.sym->executable = 1; >>
			<<aSymScope(&locals);>>
			"\(" WORD	<< aSymAdd($3.sym->symbol, $3.sym);
						   $3.sym->token = VAR;
						   $3.sym->level = LOCAL;
						   $3.sym->offset = ParmOffset; >>
			"\)"	
			body
			<<aSymRmScope(&locals); gen(Push,str(0)); gen(Return);>>
		;

body	:	"\{" decls[{$2.ival=LOCAL;}] slist "\}" ;

slist	:	( stat )* ;

stat	:	<<char L1[LabelSize], L2[LabelSize];>>
			"if" expr
				<<
					strcpy(L1,NewLabel());
					gen(Test);
					gen(JumpZ, L1);
				>>
			stat
				<<
					strcpy(L2,NewLabel());
					gen(Jump, L2);
					gen(Label,L1);
				>>
			{ "else" stat }
			<<gen(Label, L2);>>
		|   "while"
				<<
					strcpy(L1,NewLabel());
					gen(Label,L1);
				>>
			expr
				<<
					strcpy(L2,NewLabel());
					gen(Test);
					gen(JumpZ, L2);
				>>
			stat
				<<
					gen(Jump, L1);
					gen(Label,L2);
				>>
		|   "return" expr ";"	<<gen(Return);>>
		|   (	VAR  <<gen(Ref,$1.sym,Addr);>> 
			|	WORD <<Cerror("undefined variable '%s'\n", $1.sym->symbol);>>
			)
			"=" expr ";"	<<gen(Pop);>>
		|   "\{" (stat)* "\}"
		|   ";"
		;
expr	:	term ( "\+" term <<gen(Add);>> )* ;
term	:	fact ( "\*" fact <<gen(Mult);>> )* ;
fact	:	FUNC <<gen(Ref,$1.sym,Value);>> "\(" expr "\)" <<gen(Call);>>
		|	VAR  <<gen(Ref,$1.sym,Value);>> 
		|   "\-" fact		<<gen(Neg);>>
		|   Number			<<gen(Push, str($1.ival));>>
		|   "\(" expr "\)"
		;

#token Number "[0-9]+"		<< {extern int CurVal; CurVal = atoi(LexText);} >>
#token WORD "[a-z] [a-z]*"
				<<
				{
					/* Assume that two WORDs do not appear adjacently */
					register Sym *p;
					extern Sym *CurSym;
					extern int CurVal;

					p = aSymGet(LexText);
					if ( p == NULL ) p = aSymNew(LexText);
					else Token = p->token;
					CurSym = p;
				}
				>>
